package com.example.demo.LearnerLab;

import java.util.*;
import java.util.function.Consumer;
import java.util.stream.Collectors;
import java.util.stream.StreamSupport;

public abstract class People<PersonType extends Person> implements Iterable<PersonType> {

    private ArrayList<PersonType> personList;

    private People() {
        this.personList = new ArrayList<>();
    }

    public People(ArrayList<PersonType> personTypeList) {
        this.personList = personTypeList;
    }

    public People(PersonType... personTypes) {
        this.personList = new ArrayList<>(Arrays.asList(personTypes));
    }

    class anonymousSubClass extends People {}

    public void add(PersonType person) {
        personList.add(person);
    }

    public void remove(PersonType person) {
        personList.remove(person);
    }

    public int size() {
        return personList.size();
    }

    public void clear() {
        personList.clear();
    }

    public void addAll(Iterable<PersonType> personTypes) {
        personList.addAll(StreamSupport.stream(personTypes.spliterator(), false).collect(Collectors.toList()));
    }

    public PersonType findById(long id) {
        return personList.stream().filter(personType -> personType.getId() == id).collect(Collectors.toList()).get(0);
    }

    public List<PersonType> findAll() {
        return this.personList;
    }

    public PersonType getPerson(int index) {
        return personList.get(index);
    }

    @Override
    public Iterator iterator() {
        return personList.iterator();
    }

    @Override
    public void forEach(Consumer action) {
        personList.forEach(action);
    }

    @Override
    public Spliterator spliterator() {
        return personList.spliterator();
    }
}
